%define svnrev 7501
%define svndate 20080404.081256
%define svnversion 3.2.1

%define svnrelease 0.svn%{svnrev}.4

# what extra options to compile with
%define sconopts DEVELOPMENT=1 LID=1 JACK_DLL=1 WII=1

Summary: Object oriented programming environment for real-time audio and video processing
Name: supercollider
Version: %{svnversion}
Release: %{svnrelease}%{?dist}
License: GPL
Group: Applications/Multimedia
URL: http://supercollider.sourceforge.net/
Source0: supercollider-svn%{svnrev}.tar.gz
Source1: supercollider-get-svn
Patch0: supercollider-jack_client_new.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires: emacs w3m-el
Packager: Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

ExcludeArch: x86_64

BuildRequires: gcc-c++ autoconf automake libtool pkgconfig scons
BuildRequires: jack-audio-connection-kit-devel libsndfile-devel alsa-lib-devel
Buildrequires: fftw-devel
BuildRequires: emacs w3m
%if "%{fedora}" >= "7"
# needed because emacs needs alternatives to be installed
BuildRequires: chkconfig
%endif
BuildRequires: avahi-devel
BuildRequires: libX11-devel
BuildRequires: libXt-devel
%if "%{fedora}" >= "7"
BuildRequires: cwiid-devel
%endif

# chain of obsoletes for reverbs that made it into supercollider
Obsoletes: supercollider-reverb-ugens <= 1:0.20070712
Provides: supercollider-reverb-ugens = 1:%{version}-%{release}
Obsoletes: supercollider-freeverb <= 110905
Provides: supercollider-freeverb = %{version}-%{release}
Obsoletes: supercollider-gverb <= 052406
Provides: supercollider-fgverb = %{version}-%{release}

%description
SuperCollider is an object oriented programming environment for
real-time audio and video processing. It is one of the finest and most
versatile environments for signal processing and especially for
creating music applications of all kinds, such as complete
compositions, interactive performances, installations etc.

%package devel
Summary: Development files for SuperCollider
Group: Development/Libraries
Requires: supercollider = %{version}-%{release} pkgconfig 
Requires: jack-audio-connection-kit-devel alsa-lib-devel
Requires: libsndfile-devel
Requires: avahi-devel

%description devel
This package includes include files and libraries neede to develope
SuperCollider applications

%prep
%setup -q -n supercollider-svn%{svnrev}
%patch0 -p1

%build
# remove all SVN directories
find . -type d -name .svn -printf "\"%h/%f\"\n" | xargs rm -rf 

# point the default location of help to the shared install
%{__perl} -p -i -e "s|~/SuperCollider/Help|%{_datadir}/SuperCollider/Help|g" linux/scel/el/sclang-help.el

# in fedora 7 the alternatives system does not create the
# proper link when emacs is installed in a mach chroot, so
# just use the versioned binary
if [ -x "/usr/bin/emacs-22.1" ] ; then
    %{__perl} -p -i -e "s|emacs -batch|emacs-22.1 -batch|g" SConstruct
fi

scons PREFIX=%{_prefix} %{sconopts}

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}

scons install PREFIX=%{_prefix} %{sconopts} DESTDIR=%{buildroot}

# install all source code, some plugin collections may need this to build
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/
tar cf - Source | (cd %{buildroot}%{_datadir}/SuperCollider/; tar xpf -)

# install header file directories in the pkgconfig path
(cd Headers; tar cf - *) | (cd %{buildroot}%{_includedir}/SuperCollider; tar xpf -)

# install default per-user configuration files
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/configuration
%{__cp} -p linux/examples/sclang.cfg %{buildroot}%{_datadir}/SuperCollider/configuration
%{__cp} -p linux/examples/sclang.sc  %{buildroot}%{_datadir}/SuperCollider/configuration

# copy the lone linux example to the examples directory
%{__cp} -p linux/examples/onetwoonetwo.sc build/examples

# change the name of the emacs readme file
%{__mv} linux/scel/README linux/scel/README.emacs

%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc COPYING README* linux/scel/README.emacs
%doc build/examples
%{_bindir}/*
%{_libdir}/SuperCollider
%{_libdir}/*.so*
%dir %{_datadir}/SuperCollider
%{_datadir}/SuperCollider/SCClassLibrary
%{_datadir}/SuperCollider/Extensions
%{_datadir}/SuperCollider/Help
%{_datadir}/SuperCollider/configuration
%{_datadir}/emacs/site-lisp/*
# examples already included in doc above
%exclude %{_docdir}/SuperCollider

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.a
%{_includedir}/SuperCollider
%{_libdir}/pkgconfig/*
%{_datadir}/SuperCollider/Source

%changelog
* Wed Apr 16 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 3.2.1-0.svn7501.4
- build with JACK_DLL enabled and Wii support on on Fedora >= 7
  (needs cwiid-devel package)

* Tue Apr  8 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 3.2.1-0.svn7501.2
- do not use SC_USE_JACK_CLIENT_NEW which is the default, add patch0
  to eliminate the code from SC_Jack.cpp (was it truly on? I should
  double check)

* Sat Apr  5 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 3.2.1-0.svn7501.1
- updated to current svn
- no longer install /etc/sclang.cfg
- changed version numbering scheme to include the proper version
- /usr/lib/SuperCollider/plugins/ReverbUGens.so conflicts with the
  old supercollider-reverb-ugens collection (built from the
  supercollider-sc3-plugins, also supercollider-ljpc-classes,
  supercollider-dewdrop, supercollider-josh-ugens

* Fri Feb  1 2008 Arnaud Gomes-do-Vale <Arnaud.Gomes@ircam.fr>
- built on CentOS
- won't build on x86_64

* Sat Nov 17 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 
- installed Headers in the proper location that matches the pkgconfig
  CFLAGS locations

* Tue Jul 24 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 
- updated to svn from 07.07.23
- added w3m to build and run dependencies
- "source" directory is now "Source"
- added emacs readme file as README.emacs
- fix build on fc7, replace emacs with emacs-22.1

* Tue May  8 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070219-0.2.5866svn
- build on fc7, add patch0 to direct X11 path to right location

* Thu Mar  8 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070219-0.2.5866svn
- install all source files in the -devel package, some UGens (sc3-plugins)
  need the full source to build

* Wed Feb 21 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070219-0.1.5866svn
- updated to svn 5866

* Fri Jan 19 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070118-0.2.5811svn
- added Platform to /etc/sclang.conf (otherwise linux specific classes
  are not loaded)
- in fc4 remove URL tag from .pc files, the stock pkgconfig does not like
  them (later updates do but the build env does not use them)
- split -devel package, add proper requires (libhowl, avahi)

* Thu Jan 18 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070118-0.1.5811svn
- switched to svn, updated to revision 5811
- added static scsynth.a lib to files list

* Mon Jan 15 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.1.cvs
- added missing libXt-devel dependency in fc5/6

* Thu Jan 11 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.5.cvs
- build on fc5 and fc6, remove howl-devel dependency as howl is no
  longer being developed or maintained. Replace with Avahi.

* Mon Jan  8 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.5.cvs
- added howl-devel build requirement (erased openmotif-devel)
- fix removal of CVS directories (a directory with spaces in it was
  being erased by mistake)

* Thu Jan  4 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.4.cvs
- updated to cvs snapshot 2007.01.04
- add a line in /etc/sclang.cfg to include ~/.sclang.scel.cfg if exists

* Tue Dec 26 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.4.cvs
- really enable crucial and JITLib (needed \+ instead of just + in
  perl one-liner)

* Tue Dec 19 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.3.cvs
- install SCComplex.h file, Josh Parmenter's PV needs it (and anything
  using FFT_UGens.h)

* Mon Dec 18 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.2.cvs
- enabled crucial and JITlib by default in /etc/sclang.conf

* Mon Nov 27 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127
- updated get-cvs script with new urls
- updated to cvs snapshot dated 20061127.105006

* Thu Jan  5 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20060105
- updated to cvs snapshot 2006.01.05

* Fri Jul 15 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 
- added fc4/gcc4 patch posted by Russell Johnston

* Thu Jul 14 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050714
- updated to today's cvs
- add scons DEVELOPMENT option to get all the devel files built and
  installed

* Thu Jun 30 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050630
- updated to cvs snapshot 2005.06.30
- build is now scons based
- added patch for gcc4 build

* Thu May  5 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050505
- updated to cvs snapshot 2005.05.05
- added howl-devel build requirement on fc3
- create proper configuration file
- do not add ~/supercollider directory, users will need to create the
  proper subdirectories in the current directory before starting sclang

* Sun Oct  3 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20040930
- tried to --enable-lid but compile fails

* Thu Sep 30 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20040930
- cvs: 2004/09/30
- added patch to configure to add X11 library path search

* Fri Aug 13 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 2004.08.13-1
- downloaded new cvs snapshot
- many changes to spec file
- add .so.0 links for sclang and scsynth shared libraries

* Wed Jan 21 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 3.0-1.cvs
- Initial build.
- installs a /root/.sclang.cfg??
